package com.xxp.carEnter.Adapter.Home;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.lifecycle.LifecycleOwner;
import androidx.recyclerview.widget.RecyclerView;

import com.tencent.smtt.sdk.QbSdk;
import com.xxp.carEnter.Model.BannerBean;
import com.xxp.carEnter.Presenter.HomePresenter;
import com.xxp.carEnter.Presenter.view.HomeView;
import com.xxp.carEnter.R;

import java.util.List;

public class HomePageAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> implements HomeView {

    private final int HOME_BANNER = 0;
    private final int HOME_NOTICE = 1;
    private final int HOME_MENU = 2;
    private final int HOME_ADBANNER = 3;
    private final int HOME_COUNSEL = 4;
    Context context;

    LayoutInflater inflater;
    LifecycleOwner lo;

    BannerHolder bh;
    BannerHolder Ah;
    CounselHolder ch;
    HomePresenter presenter;


    public HomePageAdapter(Context context, LifecycleOwner lo) {

        this.context = context;
        inflater = LayoutInflater.from(context);
        presenter = new HomePresenter(context, this);
        this.lo = lo;

    }

    @Override
    public int getItemViewType(int position) {
        return position;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        switch (viewType) {
            case HOME_BANNER:
                return bh = new BannerHolder(inflater.inflate(R.layout.holder_main_topbanner, null), context, 0, lo, presenter);


            case HOME_ADBANNER:
                return Ah = new BannerHolder(inflater.inflate(R.layout.holder_main_banner_two, null), context, 1, lo, presenter);
            case HOME_COUNSEL:
                return ch = new CounselHolder(inflater.inflate(R.layout.holder_main_counsel, null), context);

        }

        return null;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {

    }

    @Override
    public int getItemCount() {
        return 5;
    }

    @Override
    public void reBanner(int type, List<BannerBean> beanList) {
        if (type == 0) {
            bh.InitView(beanList);
        } else {
            Ah.InitView(beanList);
        }

    }

}
