package com.xxp.carEnter.Date.Dao;

import androidx.room.Dao;
import androidx.room.Insert;
import androidx.room.Query;
import androidx.room.Update;

import com.xxp.carEnter.Date.table.RecordTable;

import java.util.List;

import io.reactivex.Completable;
import io.reactivex.Flowable;
import io.reactivex.Observable;
import io.reactivex.Single;

@Dao
public interface RecordDao {

    @Query("SELECT * FROM RecordTable WHERE meeting_id=:meetingId")
    Single<List<RecordTable>> getRecordByMeeting(String meetingId);

    @Query("SELECT * FROM RecordTable WHERE meeting_id=:meetingId and down_state=1")
    Single<List<RecordTable>> getRecordByMeetingIsDown(String meetingId);

    @Query("Select * from RecordTable where record_id=:id ")
    Single<RecordTable> getPathbyId(String id);

    @Query("Delete from RecordTable where id in (:ids)")
    Completable deleteByIds(String ids);

    @Query("Update RecordTable set down_state=1 where record_id=:rid ")
    Completable upRecordByRid(String rid);

    @Insert
    Completable insertAll(RecordTable... records);

    @Update
    Completable upRecord(RecordTable record);


}
