package com.xxp.carEnter.Date.DateBase;

import android.content.Context;
import android.util.Log;


import org.reactivestreams.Subscription;

import io.reactivex.Completable;
import io.reactivex.Flowable;
import io.reactivex.FlowableSubscriber;
import io.reactivex.Single;
import io.reactivex.SingleObserver;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.disposables.CompositeDisposable;
import io.reactivex.disposables.Disposable;
import io.reactivex.functions.Action;
import io.reactivex.functions.Consumer;
import io.reactivex.internal.observers.FutureSingleObserver;
import io.reactivex.schedulers.Schedulers;

public class BaseRepository {
    public AppDataBase db;
    private CompositeDisposable compositeDisposable = new CompositeDisposable();

    public BaseRepository(Context context) {
        db = AppDataBase.getInstance(context);
    }

    public <T> void addDisposable(Single<T> flowable, Consumer<T> single) {
        boolean add = compositeDisposable.add(flowable
                .subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(single));
    }

    public void addDisposable(Completable completable, Action action) {
        compositeDisposable.add(completable
                .subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(action));
    }


}
