package com.xxp.carEnter.Date.DateBase;

import android.content.Context;

import com.xxp.carEnter.Date.Dao.RecordDao;
import com.xxp.carEnter.Date.table.RecordTable;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.SingleObserver;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.disposables.Disposable;
import io.reactivex.functions.Action;
import io.reactivex.functions.Consumer;
import io.reactivex.schedulers.Schedulers;


public class RecordRepository extends BaseRepository {

    public RecordDao dao;

    public RecordRepository(Context context) {
        super(context);
        dao = db.recordDao();

    }

    public void getPathbyId(String id, DataCommCallBack<RecordTable> callBack) {

        dao.getPathbyId(id).subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(new SingleObserver<RecordTable>() {
                    @Override
                    public void onSubscribe(Disposable d) {

                    }

                    @Override
                    public void onSuccess(RecordTable s) {
                        callBack.callBack(s);
                    }

                    @Override
                    public void onError(Throwable e) {
                        callBack.callBack(null);
                    }
                });
    }

    public void getRecordByMeetingIsDown(String id, DataCommCallBack<List<RecordTable>> callBack) {
        dao.getRecordByMeetingIsDown(id).subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(new SingleObserver<List<RecordTable>>() {
                    @Override
                    public void onSubscribe(Disposable d) {

                    }

                    @Override
                    public void onSuccess(List<RecordTable> recordTables) {
                        callBack.callBack(recordTables);
                    }

                    @Override
                    public void onError(Throwable e) {
                        callBack.callBack(new ArrayList<>());
                    }
                });

    }

    public void getRecordByMeeting(String id, DataCommCallBack<List<RecordTable>> callBack) {
        dao.getRecordByMeeting(id).subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(new SingleObserver<List<RecordTable>>() {
                    @Override
                    public void onSubscribe(Disposable d) {

                    }

                    @Override
                    public void onSuccess(List<RecordTable> recordTables) {
                        callBack.callBack(recordTables);
                    }

                    @Override
                    public void onError(Throwable e) {
                        callBack.callBack(new ArrayList<>());
                    }
                });

    }

    public void insertAll(RecordTable... records) {
        addDisposable(dao.insertAll(records), new Action() {
            @Override
            public void run() throws Exception {

            }
        });
    }


    public void upRecord(RecordTable records) {
        addDisposable(dao.upRecord(records), new Action() {
            @Override
            public void run() throws Exception {

            }
        });
    }

    public void upStateByRid(String recordid) {
        addDisposable(dao.upRecordByRid(recordid), new Action() {
            @Override
            public void run() throws Exception {

            }
        });
    }

    public void deleteByids(String recordids) {
        addDisposable(dao.deleteByIds(recordids), new Action() {
            @Override
            public void run() throws Exception {

            }
        });
    }


}
