package com.xxp.carEnter.Date;

import android.content.Context;
import android.content.SharedPreferences;

import com.google.gson.Gson;
import com.xxp.carEnter.Model.UserBean;
import com.xxp.carEnter.Presenter.LoginPresenter;

public class SharedPreferencesUtils {



    /**
     * 获得用户信息
     *
     * @param context
     * @return
     */

    public static UserBean getUserInfo(Context context) {
        SharedPreferences share = context.getSharedPreferences("userinfo",
                Context.MODE_PRIVATE);
        UserBean userInfo = null;
        Gson gson = new Gson();
        String info = share.getString("user", "");
        try {
            if (info.length() == 0)
                return null;
            userInfo = gson.fromJson(info, UserBean.class);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return userInfo;
    }

    /**
     * 保存用户信息
     *
     * @param context
     * @param userInfo
     */
    public static void saveUserInfo(Context context, UserBean userInfo) {
        SharedPreferences share = context.getSharedPreferences("userinfo",
                Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = share.edit();
        Gson gson = new Gson();
        try {
            editor.putString("user", gson.toJson(userInfo));
        } catch (Exception e) {
            e.printStackTrace();
        }
        editor.commit();
    }


    /**
     * 獲取登錄信息
     * @param context
     * @return
     */
    public static LoginPresenter.LoginRequestBody getLoginMsg(Context context) {
        SharedPreferences share = context.getSharedPreferences("userinfo",
                Context.MODE_PRIVATE);
        LoginPresenter.LoginRequestBody loginMsg = null;
        Gson gson = new Gson();
        String info = share.getString("login", "");
        try {
            if (info.length() == 0)
                return null;
            loginMsg = gson.fromJson(info, LoginPresenter.LoginRequestBody.class);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return loginMsg;
    }

    /**
     * 保存登录信息
     *
     * @param context
     */
    public static void saveLoginMsg(Context context, LoginPresenter.LoginRequestBody loginMsg) {
        SharedPreferences share = context.getSharedPreferences("userinfo",
                Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = share.edit();
        Gson gson = new Gson();
        try {
            editor.putString("login", gson.toJson(loginMsg));
        } catch (Exception e) {
            e.printStackTrace();
        }
        editor.commit();
    }



}
