package com.xxp.carEnter.Presenter;

import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.view.View;

import com.xxp.carEnter.Date.SharedPreferencesUtils;
import com.xxp.carEnter.Date.StatesValueMap;
import com.xxp.carEnter.Model.DictBean;
import com.xxp.carEnter.Model.InUserBean;
import com.xxp.carEnter.Model.LoginBean;
import com.xxp.carEnter.Model.UserAllBean;
import com.xxp.carEnter.Model.UserBean;
import com.xxp.carEnter.Presenter.view.LoginView;
import com.xxp.carEnter.base.BasePresenter;
import com.xxp.library.httpUtil.ApiParams;
import com.xxp.library.httpUtil.BadyBean;
import com.xxp.library.httpUtil.BasePageResponselm;
import com.xxp.library.httpUtil.BaseResponse;
import com.xxp.library.httpUtil.BaseResponseIm;
import com.xxp.library.httpUtil.xxIMSubscriber;
import com.xxp.library.httpUtil.xxSubscriber;
import com.xxp.library.util.CySM4Util;
import com.xxp.library.util.xxUtil;

import org.json.JSONObject;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import okhttp3.RequestBody;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class LoginPresenter extends BasePresenter<LoginView> {

    String loginTime = "";

    public LoginPresenter(Context context, LoginView view) {
        super(context, view);
    }

    public void doLogin(String user, String pwd) {

        if (xxUtil.isEmpty(user)) {
            showLToast("请输入账号");
            return;
        }
        if (xxUtil.isEmpty(pwd)) {
            showLToast("请输入密码");
            return;
        }
        showProgressDialog();
        LoginRequestBody loginbody = new LoginRequestBody(user, pwd);
        rx.Observable<LoginBean> observable = Ip.getLoginInFo(new ApiParams<LoginRequestBody>().setParams(loginbody));
        observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new xxIMSubscriber<LoginBean>() {

            @Override
            public void onSuccess(LoginBean resultBean) {
                loginTime = resultBean.getIsLogined();
                SharedPreferencesUtils.saveLoginMsg(mContext, loginbody);

                getDict(new String[]{});
            }

            @Override
            public void onError(String Error) {
                showLToast(Error);
                dissmissProgressDialog();
            }
        });

    }

    public void getUserInfo() {
        rx.Observable<BaseResponse<UserAllBean>> observable = Ip.getUserInfo();
        observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new xxSubscriber<UserAllBean>() {
            @Override
            public void onSuccess(UserAllBean resultBean) {
                dissmissProgressDialog();
                StatesValueMap.USER_TYPE = resultBean.getUserType();
                SharedPreferencesUtils.saveUserInfo(mContext, resultBean.getObj());
                StatesValueMap.IS_LOGIN = true;
//                PushManager.getInstance().bindAlias(mContext,"Uid"+resultBean.getObj().getUserId(),resultBean.getObj().getUserId());
                mView.LoginSuc(loginTime);


            }

            @Override
            public void onError(String Error) {
                dissmissProgressDialog();
            }
        });


    }


    public class LoginRequestBody {


        private String username;

        private String password;

        public LoginRequestBody(String user, String pwd) {
            username = user;
            password = pwd;
        }


        public String getUsername() {
            return username;
        }

        public void setUsername(String username) {
            this.username = username;
        }

        public String getPassword() {
            return password;
        }

        public void setPassword(String password) {
            this.password = password;
        }
    }

    public void setPushTag() {

    }

}
