package com.xxp.carEnter.base;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import com.xxp.carEnter.Date.StatesValueMap;
import com.xxp.carEnter.R;
import com.xxp.carEnter.ui.activity.LoginActivity;
import com.xxp.carEnter.ui.dialog.TwoButtonDialog;
import com.xxp.library.Manager.AppManager;
import com.xxp.library.View.ViewUtils.xxToast;
import com.xxp.library.util.AndroidBug5497Workaround;
import com.xxp.library.util.NetUtil;
import com.xxp.library.util.xxUtil;
import com.zhy.autolayout.AutoLayoutActivity;
import com.zhy.autolayout.AutoLinearLayout;

import java.util.ArrayList;
import java.util.List;

import butterknife.ButterKnife;


public abstract class xxBaseActivity extends AutoLayoutActivity  {
    private Handler loginTimeHandler = new Handler();
    ;
    public static PermissionListener mListener;
    public static boolean netStatic = true;
    public Context mContext;
    xxToast toast;
    private Runnable runnable = new Runnable() {
        @Override
        public void run() {
            StatesValueMap.IS_LOGIN = false;
            Log.e("runner", this.toString() + "&&&" + runnable.toString());
            xxUtil.removeCookie(mContext);
            startActivity(new Intent(mContext, LoginActivity.class));
            finish();
        }
    };
    private int timeLogin = 1 * 60 * 1000;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        mContext = this;

        AppManager.getInstance().addActivity(this);

        setContentView(InitView());

        ButterKnife.bind(this);

        toast = new xxToast(mContext);
      /* if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {//版本判断
            Window window = getWindow();
// Translucent status bar
            window.setFlags(
                    WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS,
                    WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS);//设置statusbar应用所占的屏幕扩大到全屏，但是最顶上会有背景透明的状态栏，它的文字可能会盖着你的应用的标题栏
            getWindow().addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_NAVIGATION);
            getWindow().addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS);
        }*/
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            Window window = getWindow();
            window.addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS);
            window.setStatusBarColor(getResources().getColor(R.color.bg_blue));
        }

        InitData();
        IntentFilter intentFilter = new IntentFilter();
        intentFilter.addAction("android.net.conn.CONNECTIVITY_CHANGE");
    }

    public void InitTitle(String s) {
        if (findViewById(R.id.iv_back) != null) {
            findViewById(R.id.iv_back).setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    finish();
                }
            });
        }

        if (!xxUtil.isEmpty(s) && findViewById(R.id.tv_title) != null) {
            TextView title = findViewById(R.id.tv_title);
            title.setText(s);

        }
    }

    private static final int MIN_DELAY_TIME = 500;  // 两次点击间隔不能少于1000ms
    private static long lastClickTime;

    public static boolean isFastClick() {
        boolean flag = true;
        long currentClickTime = System.currentTimeMillis();
        if ((currentClickTime - lastClickTime) >= MIN_DELAY_TIME) {
            flag = false;
        }
        lastClickTime = currentClickTime;
        return flag;
    }

    public abstract int InitView();

    public abstract void InitData();

    public void ShowLToast(String stoast) {
        toast.setToast(stoast);
    }


    @Override
    public void finish() {
//        AppManager.getInstance().finishActivity();
        super.finish();

    }


    /**
     * 权限申请
     *
     * @param permissions
     */
    public void getPermissions(String[] permissions, PermissionListener listener) {
        mListener = listener;
        List<String> ps = new ArrayList<>();
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            for (String p : permissions) {
                if (ContextCompat.checkSelfPermission(mContext, p) != PackageManager.PERMISSION_GRANTED) {
                    ps.add(p);
                } else {
                    ps.add(p);
                }
            }
        }
        String[] pstr = new String[ps.size()];
        ps.toArray(pstr);
        if (ps != null && ps.size() != 0) {
            ActivityCompat.requestPermissions(this, pstr, 1);
//            if (ActivityCompat.shouldShowRequestPermissionRationale(context,))
        }

    }

    /**
     * 申请后的处理
     */
    @Override
    public void onRequestPermissionsResult(
            int requestCode, String[] permissions, int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (grantResults.length > 0) {
            List<String> deniedList = new ArrayList<>();
            // 遍历所有申请的权限，把被拒绝的权限放入集合
            for (int i = 0; i < grantResults.length; i++) {
                int grantResult = grantResults[i];
                if (grantResult == PackageManager.PERMISSION_GRANTED) {

                } else {
                    deniedList.add(permissions[i]);
                }
            }
            if (!deniedList.isEmpty()) {
                mListener.denied(deniedList);
            } else {
                mListener.granted();
            }
        }
    }


    @Override
    protected void onResume() {
        super.onResume();
        /*Log.e("runner开始", "++++++++++++++++++++++");
        if (StatesValueMap.IS_LOGIN) {

            loginTimeHandler.removeCallbacks(runnable);
            loginTimeHandler.postDelayed(runnable, timeLogin);
        } else {
            loginTimeHandler.removeCallbacks(runnable);
        }*/
        new Thread() {
            @Override
            public void run() {
                super.run();
                try {
                    Thread.sleep(3000, 0);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                /**
                 * 要执行的操作
                 */
                if (NetUtil.getNetWorkState(mContext) == NetUtil.NETWORK_NONE) {
                    netStatic = false;

                    if (findViewById(R.id.cl_bar_net) != null) {
                        findViewById(R.id.cl_bar_net).setVisibility(View.VISIBLE);
                    }
                } else {
                    netStatic = true;
                    if (findViewById(R.id.cl_bar_net) != null) {
                        findViewById(R.id.cl_bar_net).setVisibility(View.GONE);
                    }
                }
            }
        }.start();

    }

    public interface PermissionListener {
        public void denied(List<String> list);

        public void granted();
    }


    @Override
    public boolean dispatchTouchEvent(MotionEvent ev) {
       /* switch (ev.getAction()) {
            case MotionEvent.ACTION_DOWN:

                Log.e("runner离开", this.toString() + "&&&" + loginTimeHandler.toString());
                break;
            case MotionEvent.ACTION_UP:
                if (StatesValueMap.IS_LOGIN) {
                    Log.e("runner开始", this.toString() + "&&&" + loginTimeHandler.toString());
                    loginTimeHandler.removeCallbacks(runnable);
                    loginTimeHandler.postDelayed(runnable, timeLogin);
                } else {
                    loginTimeHandler.removeCallbacks(runnable);
                }

                break;
        }*/

        return super.dispatchTouchEvent(ev);
    }

    public void reLogin() {
        Log.e("runner开始", this.toString() + "&&&" + loginTimeHandler.toString());
        loginTimeHandler.removeCallbacks(runnable);
        loginTimeHandler.postDelayed(runnable, timeLogin);
    }

    @Override
    protected void onPause() {
        super.onPause();
//        loginTimeHandler.removeCallbacks(runnable);
    }
}
