package com.xxp.carEnter.ui.activity;

import android.Manifest;
import android.content.Intent;
import android.os.Build;
import android.view.KeyEvent;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;

import com.xxp.carEnter.Date.SharedPreferencesUtils;
import com.xxp.carEnter.Presenter.LoginPresenter;
import com.xxp.carEnter.Presenter.view.LoginView;
import com.xxp.carEnter.R;
import com.xxp.carEnter.Util.ActionModeCallbackInterceptor;
import com.xxp.carEnter.base.xxBaseActivity;
import com.xxp.library.Manager.AppManager;

import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

import static com.xxp.library.util.xxUtil.removeCookie;

public class LoginActivity extends xxBaseActivity implements LoginView {

    @BindView(R.id.et_login_name)
    EditText et_name;

    @BindView(R.id.et_login_pwd)
    EditText et_pwd;

    LoginPresenter presenter;

    @Override
    public int InitView() {
        return R.layout.activity_login;

    }

    @Override
    public void InitData() {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            et_pwd.setCustomSelectionActionModeCallback( new ActionModeCallbackInterceptor());
            et_name.setCustomSelectionActionModeCallback( new ActionModeCallbackInterceptor());
        }

        presenter = new LoginPresenter(mContext, this);
        getPermissions(new String[]{Manifest.permission.ACCESS_NETWORK_STATE, Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE, Manifest.permission.CAMERA, Manifest.permission.RECORD_AUDIO, Manifest.permission.ACCESS_COARSE_LOCATION, Manifest.permission.ACCESS_FINE_LOCATION}, new PermissionListener() {
            @Override
            public void denied(List<String> list) {

            }

            @Override
            public void granted() {

            }
        });
        if (SharedPreferencesUtils.getLoginMsg(mContext) != null) {
            LoginPresenter.LoginRequestBody login = SharedPreferencesUtils.getLoginMsg(mContext);
            et_name.setText(login.getUsername());
            et_pwd.setText(login.getPassword());
        }
    }

    @OnClick(R.id.btn_login)
    void OnClick(View view) {
        if (isFastClick()) {
            return;
        }
        presenter.doLogin(et_name.getText().toString(), et_pwd.getText().toString());


//        Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
//        intent.setType("*/*");
//        intent.addCategory(Intent.CATEGORY_OPENABLE);
//        try {
//            startActivityForResult( Intent.createChooser(intent, "Select a File to Upload"), 1001);
//        } catch (android.content.ActivityNotFoundException ex) {
//            // Potentially direct the user to the Market with a Dialog
//            Toast.makeText(this, "Please install a File Manager.", Toast.LENGTH_SHORT).show();
//        }
    }


    @Override
    public void LoginSuc(String loginTime) {


        finish();
    }




}
