package com.xxp.carEnter.ui.activity;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.Gravity;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;
import androidx.navigation.NavController;
import androidx.navigation.Navigation;
import androidx.navigation.fragment.NavHostFragment;
import androidx.navigation.ui.AppBarConfiguration;
import androidx.navigation.ui.NavigationUI;

import com.google.android.material.bottomnavigation.BottomNavigationItemView;
import com.google.android.material.bottomnavigation.BottomNavigationMenuView;
import com.google.android.material.bottomnavigation.BottomNavigationView;
import com.google.android.material.bottomnavigation.LabelVisibilityMode;
import com.xxp.carEnter.Date.SharedPreferencesUtils;
import com.xxp.carEnter.Date.StatesValueMap;
import com.xxp.carEnter.Model.DictBean;
import com.xxp.carEnter.Presenter.MainPresenter;
import com.xxp.carEnter.Presenter.view.MainView;
import com.xxp.carEnter.R;
import com.xxp.carEnter.base.xxBaseActivity;
import com.xxp.carEnter.base.xxBaseFragment;
import com.xxp.carEnter.ui.fragment.HomeFragment;
import com.xxp.library.Manager.AppManager;
import com.xxp.library.httpUtil.BaseResponse;
import com.xxp.library.httpUtil.xxSubscriber;
import com.xxp.library.util.NetUtil;
import com.zhy.autolayout.utils.AutoUtils;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import butterknife.BindView;
import butterknife.OnClick;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

import static com.xxp.carEnter.base.xxBaseApplication.idFrist;
public class MainActivity extends xxBaseActivity implements MainView {

    @BindView(R.id.bt_main_tab)
    BottomNavigationView bt_tab;

    @BindView(R.id.id_first_img)
    RelativeLayout iv_first;


    xxBaseFragment aF;
    xxBaseFragment hF;
    xxBaseFragment mF;
    xxBaseFragment msF;
    xxBaseFragment nF;

    BottomNavigationItemView viewMes, ViewEven;
    View dotView;
    BottomNavigationMenuView bottomNavigationMenuView;
    MainPresenter persenter;
    int time = 4;
    Timer timer = new Timer();
    Handler handler = new Handler() {
        @Override
        public void handleMessage(@NonNull Message msg) {
            super.handleMessage(msg);
            if (msg.arg1 == 0) {
                timer.cancel();
            }
        }
    };

    int redId;

    @Override
    public int InitView() {
        return R.layout.activity_main;
    }

    @Override
    public void InitData() {

        if (isSuEnable())
        {
           ShowLToast("root环境不可使用");
           AppManager.getInstance().finishAllActivity();
        }

        initFragment();
       /* if (loginTime == null || loginTime.equals("0")) {
            Intent intent = new Intent(mContext, ChangePwdActivity.class);
            intent.putExtra("first", 1);
            startActivity(intent);
        } else if (!AppManager.getInstance().getActivityNext()) {
            Intent intentM = new Intent(mContext, MainActivity.class);
            startActivity(intentM);
        }*/


        persenter = new MainPresenter(mContext, this);
        if (idFrist) {
            idFrist = false;
            TimerTask task = new TimerTask() {
                @Override
                public void run() {
                    time--;
                    Message msg = new Message();
                    msg.arg1 = time;
                    handler.sendMessage(msg);

                }
            };

            timer.schedule(task, 1000, 1000);

          /*  bt_tab.postDelayed(new Runnable() {
                @Override
                public void run() {

                }
            }, 40000);*/

        } else {
//            iv_first.setVisibility(View.GONE);
        }



//        findViewById(R.id.cl_bar_net).setVisibility(View.GONE);


        setBottomView();


    }
    /**
     * 是否存在su命令，并且有执行权限
     *
     * @return 存在su命令，并且有执行权限返回true
     */
    public static boolean isSuEnable() {
        File file = null;
        String[] paths = {"/system/bin/", "/system/xbin/", "/system/sbin/", "/sbin/", "/vendor/bin/", "/su/bin/"};
        try {
            for (String path : paths) {
                file = new File(path + "su");
                if (file.exists() && file.canExecute()) {
                    return true;
                }
            }
        } catch (Exception x) {
            x.printStackTrace();
        }
        return false;
    }

    @Override
    protected void onStart() {
        super.onStart();

    }

    @Override
    protected void onRestart() {
        super.onRestart();

    }

    public void initFragment() {
        //判断activity是否重建，如果不是，则不需要重新建立fragment.

        FragmentManager fm = getSupportFragmentManager();
        FragmentTransaction ft = fm.beginTransaction();
        if (hF == null) {
            hF = new HomeFragment();
        }
        nF = hF;
        ft.replace(R.id.f_main_context, hF).commit();
    }

    private BottomNavigationView.OnNavigationItemSelectedListener mOnNavigationItemSelectedListener = new BottomNavigationView.OnNavigationItemSelectedListener() {
        @Override
        public boolean onNavigationItemSelected(@NonNull MenuItem item) {
            switch (item.getItemId()) {
                case R.id.nav_home:
                    if (hF == null) {
                        hF = new HomeFragment();
                    }
                    switchContent(hF);
                    return true;

                case R.id.nav_msg:

                    switchContent(msF);
                    return true;

            }
            return false;
        }

    };

    public void switchContent(xxBaseFragment to) {
        if (nF != to) {

            FragmentManager fm = getSupportFragmentManager();
            //添加渐隐渐现的动画
            FragmentTransaction ft = fm.beginTransaction();
            if (!to.isAdded()) {    // 先判断是否被add过
                ft.hide(nF).add(R.id.f_main_context, to).commit(); // 隐藏当前的fragment，add下一个到Activity中
            } else {
                ft.hide(nF).show(to).commit(); // 隐藏当前的fragment，显示下一个
            }
            nF = to;
        }
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (StatesValueMap.USER_TYPE == 1 && StatesValueMap.IS_LOGIN) {
        }
        bt_tab.setItemTextAppearanceActive(R.style.bottom_selected_text);
        bt_tab.setItemTextAppearanceInactive(R.style.bottom_normal_text);

        setBottomViewmenu();
        BottomNavigationViewHelper.disableShiftMode(bt_tab);
    }

    public void setBottomView() {


        AppBarConfiguration appBarConfiguration = new AppBarConfiguration.Builder(R.id.nav_home, R.id.nav_annunciate, R.id.nav_msg, R.id.nav_web, R.id.nav_mine).build();

        NavController navController = Navigation.findNavController(this, R.id.f_main_context);

        //NavigationUI.setupActionBarWithNavController(this,navController,appBarConfiguration);

        NavigationUI.setupWithNavController(bt_tab, navController);

        bottomNavigationMenuView = (BottomNavigationMenuView) bt_tab.getChildAt(0);
        viewMes = (BottomNavigationItemView) bottomNavigationMenuView.getChildAt(3);

        ViewEven = (BottomNavigationItemView) bottomNavigationMenuView.getChildAt(2);
       /* BottomNavigationItemView redView=new ImageView(mContext);
        ViewGroup.LayoutParams params=new ViewGroup.LayoutParams(AutoUtils.getPercentHeightSize(10),AutoUtils.getPercentHeightSize(10));

        redId= redView.getId();
        redView.setLayoutParams(params);
        redView.*/
        BottomNavigationItemView.LayoutParams params = new BottomNavigationItemView.LayoutParams(AutoUtils.getPercentHeightSize(17), AutoUtils.getPercentHeightSize(17));
        params.gravity = Gravity.CENTER_HORIZONTAL;
        params.leftMargin = AutoUtils.getPercentHeightSize(17);
        params.topMargin = AutoUtils.getPercentHeightSize(17);
        ViewGroup.LayoutParams vparams = new BottomNavigationItemView.LayoutParams(AutoUtils.getPercentHeightSize(17), AutoUtils.getPercentHeightSize(17));
        dotView = new View(this);
        dotView.setBackground(getResources().getDrawable(R.drawable.bg_red_corner_20));
        dotView.setLayoutParams(vparams);
        ViewEven.addView(dotView, params);
        View view = new View(mContext);
//        bottomNavigationMenuView.getChildAt(4).setVisibility(View.GONE);
        bottomNavigationMenuView.removeViewAt(2);
        bottomNavigationMenuView.addView(view, 2);
        //  BottomNavigationItemView bottomCentreItemView = (BottomNavigationItemView) bottomNavigationMenuView.getChildAt(2);
//        bottomNavigationItemView = (BottomNavigationItemView) bottomNavigationMenuView.getChildAt(4);
    }

    public void setBottomViewmenu() {


        if (!StatesValueMap.IS_LOGIN) {
            bt_tab.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    startActivity(new Intent(MainActivity.this, LoginActivity.class));
                }
            });
            bottomNavigationMenuView.getChildAt(3).setClickable(false);
            bottomNavigationMenuView.getChildAt(1).setClickable(false);
            bottomNavigationMenuView.getChildAt(4).setClickable(false);
           /* if (bottomNavigationMenuView.getChildAt(4) == bottomNavigationItemView) {

                TextView tv = new TextView(mContext);
                tv.setText("未登录");
                tv.setTextSize(19 * AutoUtils.getPercentHeight1px());
                tv.setGravity(Gravity.CENTER);
                tv.setTextColor(getResources().getColor(R.color.tv_gray));
                bottomNavigationMenuView.removeView(bottomNavigationItemView);
                bottomNavigationMenuView.addView(tv);
            }*/


        } else {
            bt_tab.setOnNavigationItemSelectedListener(mOnNavigationItemSelectedListener);
            bottomNavigationMenuView = (BottomNavigationMenuView) bt_tab.getChildAt(0);
            bottomNavigationMenuView.removeViewAt(3);

            if (StatesValueMap.hasApprove(SharedPreferencesUtils.getUserInfo(mContext).getRoleIds())) {
                bottomNavigationMenuView.addView(ViewEven, 3);
                bottomNavigationMenuView.getChildAt(3).setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        if (netStatic) {

                        } else {
                            ShowLToast("当前网络未连接，请检查您的网络设置");
                        }

                    }
                });

            } else {
                bottomNavigationMenuView.addView(viewMes, 3);
                bottomNavigationMenuView.getChildAt(3).setClickable(true);
            }

            bottomNavigationMenuView.getChildAt(1).setClickable(true);
            bottomNavigationMenuView.getChildAt(4).setClickable(true);
            bottomNavigationMenuView.getChildAt(2).setClickable(true);
            bottomNavigationMenuView.getChildAt(3).setClickable(true);
            bottomNavigationMenuView.getChildAt(2).setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {

                }
            });
            bt_tab.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
//                    toWeb(mContext, StatesValueMap.NET_URL + "approval?", "processName=审批");
                }
            });


        }
    }






    public static class BottomNavigationViewHelper {

        @SuppressLint("RestrictedApi")
        public static void disableShiftMode(BottomNavigationView view) {
            BottomNavigationMenuView menuView = (BottomNavigationMenuView) view.getChildAt(0);

            try {
                menuView.setLabelVisibilityMode(LabelVisibilityMode.LABEL_VISIBILITY_LABELED);
                for (int i = 0; i < menuView.getChildCount(); i++) {
                    if (i == 2) {
                        continue;
                    }
                    BottomNavigationItemView item = (BottomNavigationItemView) menuView.getChildAt(i);
                    item.setShifting(false);
                }
            } catch (Exception e) {

            }
        }
    }
}
