package com.xxp.carEnter.ui.dialog;

import android.content.Context;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import androidx.annotation.NonNull;

import com.xxp.carEnter.R;
import com.xxp.library.Dialog.xxBaseDialog;
import com.zhy.autolayout.utils.AutoUtils;

public class TwoButtonDialog extends xxBaseDialog {

    TextView tv_title, tv_main;
    public Button btn_sure, btn_cancel;
    String title, main;

    public TwoButtonDialog(@NonNull Context context, String title, String main) {
        super(context);
        this.title = title;
        this.main = main;
    }

    @Override
    public DialogSet InitView() {
        DialogSet set = new DialogSet(R.layout.dailog_two_button, true, Gravity.CENTER, true);
        return set;
    }

    @Override
    public void InitData() {

        tv_main = findViewById(R.id.tv_dailog_main);
        tv_title = findViewById(R.id.tv_dailog_title);
        btn_cancel = findViewById(R.id.btn_dialog_cancel);
        btn_sure = findViewById(R.id.btn_dialog_sure);
        AutoUtils.autoSize(btn_cancel);
        AutoUtils.autoSize(btn_sure);
        tv_title.setText(title);
        tv_main.setText(main);
    }

    public void setBtnClickListener(CallBackListener callBackListener) {
        btn_sure.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                callBackListener.setSureListener();
            }
        });

        btn_cancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                callBackListener.setCancleListener();
            }
        });
    }


    public interface CallBackListener {
        public void setSureListener();

        public void setCancleListener();

    }

}
