package com.xxp.carEnter.ui.dialog;

import android.content.Intent;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.FragmentActivity;

import com.huantansheng.easyphotos.EasyPhotos;
import com.huantansheng.easyphotos.callback.SelectCallback;
import com.xxp.carEnter.R;
import com.xxp.library.Dialog.xxBaseDialog;
import com.xxp.library.util.GlideEngine;

public class choicePicWayDialog extends xxBaseDialog implements View.OnClickListener {

    TextView tv_camera, tv_photo,tv_file;
    ImageView btn_cancle;
    FragmentActivity mcontext;
    SelectCallback callback;
    int photoNum = 1;
    OnDismissCallBack disCallBack;
    int disType = 0;
    String[] type;//1:有文件

    public choicePicWayDialog(@NonNull FragmentActivity context, SelectCallback callback) {
        super(context);
        mcontext = context;
        this.callback = callback;
    }

    public choicePicWayDialog(@NonNull FragmentActivity context, SelectCallback callback,String[] type) {
        super(context);
        mcontext = context;
        this.callback = callback;
        this.type=type;
    }


    @Override
    public DialogSet InitView() {
        return new DialogSet(R.layout.dialog_choice_way_pic, true, Gravity.BOTTOM, true);
    }

    @Override
    public void InitData() {
        tv_camera = findViewById(R.id.tv_chiocepic_camera);
        tv_photo = findViewById(R.id.tv_chiocepic_photo);
        btn_cancle = findViewById(R.id.btn_chiocepic_cancle);
        tv_file=findViewById(R.id.tv_chiocepic_file);
        if (type==null || type.length<=0)
        {
            tv_file.setVisibility(View.GONE);
        }
        tv_photo.setOnClickListener(this);
        tv_camera.setOnClickListener(this);
        btn_cancle.setOnClickListener(this);
        tv_file.setOnClickListener(this);
    }

    public void setPhotoNum(int num) {
        photoNum = num;
    }


    @Override
    public void onClick(View v) {
        int id = v.getId();
        if (id == R.id.tv_chiocepic_camera) {
            EasyPhotos.createCamera(mcontext)//参数说明：上下文
//                    .setFileProviderAuthority("com.xxp.library.fileprovider")//参数说明：见下方`FileProvider的配置`
                    .setFreeStyleCropEnabled(true)//是否自由剪裁
                    .isCompress(true)//是否压缩
                    .isCrop(true)//是否剪裁
                    .start(callback);
            disType = 1;
            dismiss();
        } else if (id == R.id.tv_chiocepic_photo) {
            EasyPhotos.createAlbum(mcontext, false, GlideEngine.getInstance()).setCount(photoNum).setFreeStyleCropEnabled(true).isCompress(true).isCrop(true) //参数说明：上下文，是否显示相机按钮，[配置Glide为图片加载引擎](https://github.com/HuanTanSheng/EasyPhotos/wiki/12-%E9%85%8D%E7%BD%AEImageEngine%EF%BC%8C%E6%94%AF%E6%8C%81%E6%89%80%E6%9C%89%E5%9B%BE%E7%89%87%E5%8A%A0%E8%BD%BD%E5%BA%93)
                    .start(callback);
            disType = 1;
            dismiss();
        } else if (id == R.id.btn_chiocepic_cancle) {
            dismiss();
        }else if (id==R.id.tv_chiocepic_file)
        {
            if (type!=null || type.length>=1)
            {
                Intent intent = new Intent(Intent.ACTION_GET_CONTENT);


                intent.setType("application/pdf");//pwd
                intent.setType("application/vnd.ms-powerpoint");//ppt
                intent.setType("application/vnd.ms-excel");//excel
                intent.setType("application/msword");//word
                intent.setType("text/plain");//文本
                intent.setType("text/html");//html
//                intent.setType("video/*");//视频
//                intent.setType("audio/*");//音频
                intent.addCategory(Intent.CATEGORY_OPENABLE);
                mcontext.startActivityForResult(intent, 12007);
            }
        }

    }

    @Override
    public void dismiss() {
        super.dismiss();
        if (disCallBack != null && disType == 0) {
            disCallBack.onDismiss();
        }
        disType = 0;

    }

    public void setOnDismissClaaBack(OnDismissCallBack dCallBack) {
        disCallBack = dCallBack;
    }

    public interface OnDismissCallBack {
        void onDismiss();
    }

}
