package com.xxp.carEnter.ui.fragment;

import android.Manifest;
import android.content.Intent;
import android.os.Bundle;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.xxp.carEnter.Adapter.Home.HomePageAdapter;
import com.xxp.carEnter.Date.SharedPreferencesUtils;
import com.xxp.carEnter.Date.StatesValueMap;
import com.xxp.carEnter.Model.BannerBean;
import com.xxp.carEnter.Presenter.HomeBasePresenter;
import com.xxp.carEnter.Presenter.HomePresenter;
import com.xxp.carEnter.Presenter.view.HomeBaseView;
import com.xxp.carEnter.Presenter.view.HomeView;
import com.xxp.carEnter.R;
import com.xxp.carEnter.base.xxBaseActivity;
import com.xxp.carEnter.base.xxBaseFragment;
import com.xxp.carEnter.ui.activity.LoginActivity;
import com.xxp.carEnter.ui.activity.ScanActivity;
import com.xxp.library.util.StateValue;

import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

import static com.xxp.carEnter.base.xxBaseActivity.netStatic;

/**
 * A simple {@link Fragment} subclass.
 * Use the {@link HomeFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class HomeFragment extends xxBaseFragment implements HomeBaseView {


    public static final int INTENT_SCAN = 3001;

    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private static final String ARG_PARAM1 = "param1";
    private static final String ARG_PARAM2 = "param2";

    // TODO: Rename and change types of parameters
    private String mParam1;
    private String mParam2;

    @BindView(R.id.rv_main)
    RecyclerView rv_main;


    @BindView(R.id.iv_main_scan)
    ImageView iv_scan;

    @BindView(R.id.iv_main_message_num)
    ImageView iv_msg_num;

    @BindView(R.id.iv_main_message)
    ImageView iv_message;


    public HomeFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment HomeFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static HomeFragment newInstance(String param1, String param2) {
        HomeFragment fragment = new HomeFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PARAM1, param1);
        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            mParam1 = getArguments().getString(ARG_PARAM1);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }
    }

    @Override
    public int setLayout() {
        return R.layout.fragment_home;
    }

    @Override
    public void setInit() {
        HomeBasePresenter presenter = new HomeBasePresenter(mContext, this);
        if (!StatesValueMap.IS_LOGIN) {
            iv_message.setVisibility(View.GONE);
        } else {
            if (StatesValueMap.hasApprove(SharedPreferencesUtils.getUserInfo(mContext).getRoleIds())) {
                iv_message.setVisibility(View.VISIBLE);

            } else {
                iv_message.setVisibility(View.GONE);
            }


        }

        LinearLayoutManager lm = new LinearLayoutManager(mContext, LinearLayoutManager.VERTICAL, false);
        HomePageAdapter homeAdapter = new HomePageAdapter(mContext, getViewLifecycleOwner());
        rv_main.setLayoutManager(lm);
        rv_main.setAdapter(homeAdapter);


    }


    @OnClick({R.id.iv_main_scan, R.id.iv_main_message})
    public void setOnClick(View view) {
        if (!StatesValueMap.IS_LOGIN) {
            Intent intentLogin = new Intent(getActivity(), LoginActivity.class);
            startActivity(intentLogin);
            return;
        } else if (!netStatic) {
            return;
        }
        switch (view.getId()) {

            case R.id.iv_main_scan:

                getPermissions(new String[]{Manifest.permission.CAMERA}, new xxBaseActivity.PermissionListener() {
                    @Override
                    public void denied(List<String> list) {
                        ShowLToast("请打开调用摄像权限");
                    }

                    @Override
                    public void granted() {
                        Intent sintent = new Intent(getActivity(), ScanActivity.class);
                        startActivityForResult(sintent, INTENT_SCAN);

                    }
                });


                break;


        }
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
    }


    @Override
    public void reNum(int num) {
        if (num <= 0) {
            iv_msg_num.setVisibility(View.GONE);
        } else {
            iv_msg_num.setVisibility(View.VISIBLE);

        }
    }
}